﻿SLoTe = {};
local SLoTe = SLoTe;
SLoTe.frame = CreateFrame("Frame");
local frame = SLoTe.frame;  
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("UI_ERROR_MESSAGE")
frame:RegisterEvent("CHAT_MSG_LOOT")
frame:RegisterEvent("CHAT_MSG_MONEY")
frame:RegisterEvent("LOOT_OPENED")
local Deformat = LibStub("LibDeformat-3.0")

Activation = 0
Show = 0 
loaded = 0
skipItem = 0
calc = 0
isOpened = 0
recentError = 0
initLoot = 0
itemLink = nil
amount = nil
numItems = nil
BINDING_HEADER_ScrollingLootText = "Scrolling Loot Text";
BINDING_NAME_SLoTe = "On/Off Function";


local YOU_LOOT_MONEY = _G.YOU_LOOT_MONEY
local LOOT_MONEY_SPLIT = _G.LOOT_MONEY_SPLIT
local LOOT_ITEM_SELF_MULTIPLE = _G.LOOT_ITEM_SELF_MULTIPLE
local LOOT_ITEM_SELF = _G.LOOT_ITEM_SELF
local LOOT_ITEM_CREATED_SELF = _G.LOOT_ITEM_CREATED_SELF
local GOLD_AMOUNT = _G.GOLD_AMOUNT
local SILVER_AMOUNT = _G.SILVER_AMOUNT
local COPPER_AMOUNT = _G.COPPER_AMOUNT

function frame.OnEvent(self, event, arg1, arg2)
	
	if (event == "ADDON_LOADED") and (loaded == 0) then
		
		if Activation == 0 then
			ChatFrame1:AddMessage("|cFF1A16CESLoTe initialized, it is |cFFD80000Deactivated|cFF1A16CE, enter |cFFFFFFFF*/SLoTe help* |cFF1A16CEif you need |cFF25C510help |cFF1A16CEit.|r")
			loaded = 1   
		elseif Activation == 1 then
			ChatFrame1:AddMessage("|cFF1A16CESLoTe initialized, it is |cFF25C510Activated|cFF1A16CE. enter |cFFFFFFFF*/SLoTe help* |cFF1A16CEif you need |cFFD80000help |cFF1A16CEit.|r")
			loaded = 1
			
		end
	end

	if event == "UI_ERROR_MESSAGE" and arg1 == ERR_INV_FULL and (loaded == 1) then
			CombatText_AddMessage("INVENTORY IS FULL", CombatText_StandardScroll, 1, 0, 0);
	end

	if (loaded == 1) and (event == "LOOT_OPENED") and (Show == 1) then
		LootFrame:SetClampedToScreen(false);
		LootFrame:ClearAllPoints();	
	end

	if (event == "CHAT_MSG_LOOT") and (loaded == 1) then
		
		itemLink, amount = getLoot(arg1);
		local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount, iEqLoc, iTexture, iSellPrice = GetItemInfo(itemLink);
		lootTexture = iTexture;
		lootName = sName;
		lootQuantity = amount;
		rarity = iRarity;
		
		local r, g, b, hex = GetItemQualityColor(rarity);
		if lootQuantity >= 2 then
			CombatText_AddMessage("|T".. lootTexture ..":22:22:0:0|t".." "..lootQuantity.." x "..lootName, CombatText_StandardScroll, r, g, b);
		else
			CombatText_AddMessage("|T".. lootTexture ..":22:22:0:0|t".." "..lootName, CombatText_StandardScroll, r, g, b);
		end
	end


	if (event == "CHAT_MSG_MONEY") and (loaded == 1) then
		local moneystring = Deformat(arg1, LOOT_MONEY_SPLIT) or Deformat(arg1, YOU_LOOT_MONEY)
		local aIDNumber, aName, aPoints, aCompleted, aMonth, aDay, aYear, aDescription, aFlags, aImage, aRewardText = GetAchievementInfo(1180);


		CombatText_AddMessage("|T".. aImage ..":22:22:0:0|t"..moneystring, CombatText_StandardScroll, 255, 255, 255);
		
		
	end
	

end


function getLoot(chatmsg)
	-- check for multiple-item-loot
	local itemLink, amount = Deformat(chatmsg, LOOT_ITEM_SELF_MULTIPLE)
	if not itemLink then
		itemLink, amount = Deformat(chatmsg, LOOT_ITEM_PUSHED_SELF_MULTIPLE)
	end

	-- check for single-itemloot
	if not itemLink then
		itemLink = Deformat(chatmsg, LOOT_ITEM_SELF)
	end
	if not itemLink then
		itemLink, amount = Deformat(chatmsg, LOOT_ITEM_PUSHED_SELF)
	end


	-- if something has been looted
	if itemLink then
		if not amount then
			amount = 1
		end
		return itemLink, amount
		
	end
end

function SLoTe_Command(arg1)
	if arg1 == "help" then
		ChatFrame1:AddMessage("Use /SLoTe activate/deactivate or enable/disable to use it.")
		ChatFrame1:AddMessage("Use /SLoTe show/hide to set if the loot window will be shown.")
	elseif arg1 == "activate" or arg1 == "enable" then
		activate();
	elseif arg1 == "deactivate" or arg1 == "disable" then
		deactivate();
	elseif arg1 == "show" then
		show();
	elseif arg1 == "hide" then
		hide();
	else
		ChatFrame1:AddMessage("|cFF25C510Enter /SLoTe help to show commands.|r")
	end
end

function activate()
		Activation = 1
		ChatFrame1:AddMessage("|cFF25C510SLoTe activated.|r")
end

function deactivate()
		Activation = 0
		ChatFrame1:AddMessage("|cFFD80000SLoTe deactivated.|r")
end

function show()
	ChatFrame1:AddMessage("|cFF25C510SLoTeLoot activated.|r")
	Show = 1;
end

function hide()
	Show = 0;
	ChatFrame1:AddMessage("|cFFD80000SLoTeLoot deactivated.|r")
end

SlashCmdList["SLoTe"] = SLoTe_Command;
SLASH_SLoTe1 = "/SLoTe";

frame:SetScript("OnEvent", frame.OnEvent);